/* _sp2m.h -- header file for _sp2m */

#include "std.h"

#define USAGE	"Usage: _sp2m [-NH] file1 file2 ..."
#define HELP	"HELP MESSAGE OF _SP2M\n\
  Convert Natsuhara\'s SPIN2 file V2.0, H. Tanaka, 2015\n\
  ONLY for OLD format files (_*.txt) and the output data are for use by\n\
  \"pdemag\" or \"pdirec\". For new format files (*.txt) use \"sp2m\".\n\
\n\
Usage:\n\
  _sp2m [-NH] file1 file2 ...\n\
\n\
Options:\n\
  N -- for NRM measurements and output format is for \"pdirec\"\n\
  H -- shows a help message\n\
\n\
Input files:\n\
  Natsuhara\'s old formatted file (_*.txt) of SPIN2, which are\n\
  either of step-wise demagnetization data from a single sample,\n\
  or NRM measurements of multiple samples from a single site.\n\
  Reads <=50 files but use of a wild card \"*\" is NOT supported.\n\
\n\
Output files:\n\
  Results are written to stdout with either of the following formats.\n\
    Default (for use by \"pdemag\"):\n\
      $ sample azim plun strik dip (take those only once from 1st line)\n\
      step M Ic Dc                 (inc & dec are in core frame)\n\
        ...\n\
        ...\n\
    N option (for use by \"pdirec\"):\n\
      $ file\n\
      sample Ic Dc Is Ds It Dt -1.0 A 1 M (\"-1.0 A 1\" are dummies)\n\
        ...\n\
        ...\n\
  To save to a file use redirect as \"_sp2m file1 file2 ... > outfile\"\n\
(Q to quit)"

/* some definitions */

#define NFILES	50
#define LFILES	200
#define LBUF	200

/* for use in "unsigned Opt" */

#define NRM_BIT		1

/* use when call bufparam() */

#define OSTR 0
#define ODIP 1
#define TSTR 2
#define TDIP 3
#define XDAT 4
#define YDAT 5
#define ZDAT 6
#define MAG  7
#define INC  8
#define DEC  9

/* functions */

int _sp2m_cmd(); void revorder();
void _sp2m_cal(), get_apsd(); double bufparam();
void _sp2m_caln();
