/* _sp2m_cal -- take data from nth spinner file 
		modified to read old style file (_*.txt) of Spinner 2000   080712
	WARNING: only OSTR, ODIP, XDAT, YDAT, ZDAT are modified.
*/

#include <string.h>
#include <stdlib.h>
#include "_sp2m.h"

#define ERRMSG "_sp2m_cal: error in reading a file!"
#define CONT0 "$ %s %6.1f %5.1f %6.1f %5.1f\n"
#define CONT "%4s %10.3e %5.1f %6.1f\n"

extern char Files[][LFILES];

void _sp2m_cal(n)
int n;
{
	FILE *fp;
	char step[50], buf[LBUF], s[LBUF];
	double azim, plun, strik, dip, x, y, z, mag, inc, dec;

	if ((fp = fopen(Files[n], "r")) == NULL) error("_sp2m_cal: error in fopen!");
	if (getstr(fp, buf, LBUF) == EOF) error(ERRMSG);  /* head line */
	get_apsd(buf, &azim, &plun, &strik, &dip);
	rewind(fp);  /* return to head */
	fprintf(stdout, CONT0, Files[n], azim, plun, strik, dip);
	while (getstr(fp, buf, LBUF) != EOF){  /* 1st line */
		strcpy(s, buf);
		strcpy(step, strtok(s, " ("));
		if (getstr(fp, buf, LBUF) == EOF) error(ERRMSG);
		if (getstr(fp, buf, LBUF) == EOF) error(ERRMSG);
		if (getstr(fp, buf, LBUF) == EOF) error(ERRMSG);  /* 4th line */
		x = bufparam(buf, XDAT);   y = bufparam(buf, YDAT);   z = bufparam(buf, ZDAT);
		if (getstr(fp, buf, LBUF) == EOF) error(ERRMSG);
		if (getstr(fp, buf, LBUF) == EOF) error(ERRMSG);
		if (getstr(fp, buf, LBUF) == EOF) error(ERRMSG);
		if (getstr(fp, buf, LBUF) == EOF) error(ERRMSG);  /* 8th line */
		carmag(x, y, z, &mag, &inc, &dec);
		fprintf(stdout, CONT, step, mag, inc, dec);
	}
	fclose(fp);
}

/* bufparam -- get one datum as double (Os,Od,Ts,Td,X,Y,Z,Dec,Inc,Mag) from buffer */

double bufparam(buf, param)
char *buf;
int param;
{
	char *p, sdum[20];

	switch (param){
	case OSTR:
		if ((p = strstr(buf, "O(s,d)=")) == NULL) error("bufparam: no O(s,d)=");
		strncpy(sdum, p+7, 6);   sdum[6] = '\0';
		break;
	case ODIP:
		if ((p = strstr(buf, "O(s,d)=")) == NULL) error("bufparam: no O(s,d)=");
		strncpy(sdum, p+14, 5);   sdum[5] = '\0';
		break;
	case TSTR:
		if ((p = strstr(buf, "T(s,d)=")) == NULL) error("bufparam: no T(s,d)=");
		strncpy(sdum, p+7, 6);   sdum[6] = '\0';
		break;
	case TDIP:
		if ((p = strstr(buf, "T(s,d)=")) == NULL) error("bufparam: no T(s,d)=");
		strncpy(sdum, p+14, 5);   sdum[5] = '\0';
		break;
	case XDAT:
		if ((p = strstr(buf, "X=")) == NULL) error("bufparam: no X=");
		strncpy(sdum, p+2, 10);   sdum[10] = '\0';
		break;
	case YDAT:
		if ((p = strstr(buf, "Y=")) == NULL) error("bufparam: no Y=");
		strncpy(sdum, p+2, 10);   sdum[10] = '\0';
		break;
	case ZDAT:
		if ((p = strstr(buf, "Z=")) == NULL) error("bufparam: no Z=");
		strncpy(sdum, p+2, 10);   sdum[10] = '\0';
		break;
	case MAG:
		if ((p = strstr(buf, "Jr=")) == NULL) error("bufparam: no Jr=");
		strncpy(sdum, p+3, 10);   sdum[10] = '\0';
		break;
	case INC:
		if ((p = strstr(buf, "Inc=")) == NULL) error("bufparam: no Inc=");
		strncpy(sdum, p+4, 5);   sdum[5] = '\0';
		break;
	case DEC:
		if ((p = strstr(buf, "Dec=")) == NULL) error("bufparam: no Dec=");
		strncpy(sdum, p+4, 6);   sdum[6] = '\0';
		break;
	default:
		error("bufparam: error of param!");
	}
	return atof(sdum);
}

/* get_apsd -- get azimus, plunge, strik, and dip from the first sample */

void get_apsd(buf, azim, plun, strik, dip)
char *buf;
double *azim, *plun, *strik, *dip;
{
	*azim = *plun = *strik = *dip = 0.;
	if (strstr(buf, "O(s,d)=") != NULL){
		if (strstr(buf, "T(s,d)=") != NULL){
			*azim = bufparam(buf, OSTR);   *plun = bufparam(buf, ODIP);
			*strik = bufparam(buf, TSTR);   *dip = bufparam(buf, TDIP);
		}
		else {
			*azim = bufparam(buf, OSTR);   *plun = bufparam(buf, ODIP);
		}
	}
	else if (strstr(buf, "T(s,d)=") != NULL){
		*strik = bufparam(buf, TSTR);   *dip = bufparam(buf, TDIP);
	}
}
#undef ERRMSG
#undef CONT0
#undef CONT
