/* ig_cmd -- command interpretation for igrf */

#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include "igrf.h"

#define HEADF "** Only geodetic system for file read! **\n\
Contiue? (Rtn or Y/N)"

extern FILE *Fp;
extern char Filed[];
extern unsigned int Opt;
extern int Gtype;

void ig_cmd(argc, argv)
int argc;
char *argv[];
{
	char *s;
	int flagf = 0;

	while (--argc > 0){
		if (*argv[argc] == '-'){
			s = argv[argc] + 1;
			switch (toupper(*s)){
			case 'C':
				if (Opt & READFILE_BIT){
					ig_readf_msg();
					break;
				}
				Gtype = GEOCENTRIC;
				break;
			case 'Y':
				if (Opt & READFILE_BIT) break;
				Opt |= YMD_BIT;
				break;
			case 'D':
				if (Opt & READFILE_BIT) break;
				Opt |= DEGMIN_BIT;
				break;
			case 'U':
				error(USAGE);
				break;
			case 'H':
				showless(HELP);
				break;
			case 'F':
				if (Gtype == GEOCENTRIC) ig_readf_msg();
				Opt |= READFILE_BIT;
				break;
			default:
				error("Unknown option!");
				break;
			}
		}
		else {
			if (flagf != 0) error("Assign only one file!");
			strcpy(Filed, argv[argc]);
			flagf = 1;
		}
	}
	if (flagf == 1){
		if (Opt & READFILE_BIT){
			if ((Fp=fopen(Filed,"r"))==NULL) error("Error of open file!");
		}
		else
			error("Unknown option or missing -F option!");
	}
	else if (Opt & READFILE_BIT)
			error("Missing an input file!");
}

/* ig_readf_msg */

void ig_readf_msg()
{
	fprintf(stderr, "%s", HEADF);
	if (yorn("", +1) == ZERO) exit(1);
	Gtype = GEODETIC;
	Opt &= ~YMD_BIT;  Opt &= ~DEGMIN_BIT;
}
#undef HEADF
