/* ig_readf -- read all daa from a file */

#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "igrf.h"

#define CONT "** IGRF elements from %s **\n%s\n"

extern FILE *Fp;
extern char Filed[NFILENAME], *Cont0[], *Cont1[], *Cont1y[], *Cont2, *Cont2d, *Cont3, *Cont4;
extern int Gtype, Yr, Mo, Dy, Latd, Latm, Lond, Lonm;
extern double Dyear, Htgd, Lat, Lon, X, Y, Z, I, D, F, **G, **H;

void ig_readf(ng)
int ng;
{
	char s1[50], s2[50], s3[50], s4[50], s5[50];
	int flagy, n, idum;

	printf(CONT, Filed, Cont0[Gtype]);
	Dyear = 2020.;   Htgd = 0.;   flagy = 0;
	if ((gausscoeff(Dyear,ng,G,H)) == -1) error("Error in gausscoeff!");
	while ((n=get_s(Fp,5,s1,s2,s3,s4,s5)) != EOF){
		if (n==0 || s1[0]=='#' || s1[0]=='%') continue;
		if (strcmp(s1,"$") == 0){
			if (flagy == 0) flagy = 1;
			if (n >= 4){
				Yr = atoi(s2);  Mo = atoi(s3);  Dy = atoi(s4);
				Dyear = ymdtoy(Yr, Mo, Dy, &idum);
				if (n >= 5) Htgd = atof(s5);
				else Htgd = 0.;
				if (ig_check_yr(Yr) == -1) exit(1);
				if (ig_check_mody(Mo,Dy) == -1) exit(1);
				if (ig_check_dyear(Dyear) == -1) exit(1);
				if (Htgd<-10. || Htgd>500.)
					error("** Error in altitude (-10 ~ 500 km)! **\n");
				printf(Cont1y[Gtype], Yr, Mo, Dy, Htgd);
			}
			if (n==3 || n==2){
				Dyear = atof(s2);
				Htgd = 0.;
				if (n == 3) Htgd = atof(s3);
				if (ig_check_dyear(Dyear) == -1) exit(1);
				if (Htgd<-10. || Htgd>500.)
					error("** Error in altitude (-10 ~ 500 km)! **\n");
				printf(Cont1[Gtype], Dyear, Htgd);
			}
			if (n == 1)
				error("** Error in $ date line! **");
			if ((gausscoeff(Dyear,ng,G,H)) == -1) error("Error in gausscoeff!");
		}
		else {
			if (flagy == 0){
				printf(Cont1[Gtype], Dyear, Htgd);
				flagy = 1;
			}
			if (n >= 4){
				Latd = atoi(s1);  Latm = atoi(s2);
				Lond = atoi(s3);  Lonm = atoi(s4);
				if (ig_check_degmin(Latd,Latm,Lond,Lonm,&Lat,&Lon) == -1) exit(1);
				printf(Cont2d, Latd, Latm, Lond, Lonm);
			}
			if (n==3 || n==1)
				error("** Error of a line of the site location! **");
			if (n == 2){
				Lat = atof(s1);  Lon = atof(s2);
				if (ig_check_latlon(Lat,Lon) == -1) exit(1);
				printf(Cont2, Lat, Lon);
			}
			gaussfld(Gtype, Lat, Lon, Htgd, ng, &X, &Y, &Z, G, H);
			carmag(X, Y, Z, &F, &I, &D);
			checklon(&D, 1);
			if (Lat<LTNPOLE && Lat>LTSPOLE)
				printf(Cont3, X, Y, Z, F, I, D);
			else
				printf(Cont4, Z, F, I, sqrt(X*X+Y*Y));
		}
	}
}
#undef CONT
