/* ig_site -- input of site location */

#include "igrf.h"

#define CONT "Lat_deg, Lat_min, Lon_deg, Lon_min? (Q - quit)\n\
(Set \"negative\" only to \"deg\" for south & west values)\n"

int ig_site(lat, lon)
double *lat, *lon;
{
	extern unsigned int Opt;
	extern int Latd, Latm, Lond, Lonm;
	int c;

	if (!(Opt & DEGMIN_BIT)){
		while ((c=inpd("Decimal Lat, Lon? (Q - quit)",2,lat,lon)) != ZERO){
			if (c == -1) continue;
			if (ig_check_latlon(*lat,*lon) == -1) continue;
			return(1);
		}
		return(-1);
	}
	else {
		while ((c=inpi(CONT,4,&Latd,&Latm,&Lond,&Lonm)) != ZERO){
			if (c == -1) continue;
			if (ig_check_degmin(Latd,Latm,Lond,Lonm,lat,lon) == -1) continue;
			return(1);
		}
		return(-1);
	}
}

/* ig_check_latlon */

int ig_check_latlon(lt, ln)
double lt, ln;
{
	if (lt>90. || lt<-90. || ln<-360. || ln>360.){
		fprintf(stderr, "** Lat or Lon must be in error! **\n");
		return(-1);
	}
	return(1);
}

/* ig_check_degmin */

int ig_check_degmin(ltd, ltm, lnd, lnm, lt, ln)
int ltd, ltm, lnd, lnm;
double *lt, *ln;
{
	if (ltm<0 || ltm>59 || lnm<0 || lnm>59){
		fprintf(stderr, "** Minutes must be in error! **\n");
		return(-1);
	}
	if (ltd > 0)
		*lt = (double)ltd + (double)ltm/60.;
	else
		*lt = (double)ltd - (double)ltm/60.;
	if (lnd > 0)
		*ln = (double)lnd + (double)lnm/60.;
	else
		*ln = (double)lnd - (double)lnm/60.;
	if (ig_check_latlon(*lt,*ln) == -1)
		return(-1);
	return(1);
} 
#undef CONT
