/* igrf.h -- header file for igrf   0420 */

#include "std.h"

#define USAGE "Usage: igrf [-C -Y -D -U -H] [-F file]"

#define HELP "HELP MESSAGE OF IGRF\n\
  Main field from IGRF-13 with n=m=10 V.1, H. Tanaka, 2020\n\
Usage:\n\
  igrf [-C -Y -D -U -H] [-F file]\n\
Options:\n\
  C -- calculation with geocentric coordinate system\n\
       (default: geodetic coordinate system WGS84)\n\
  Y -- input of date in \"year month day\"\n\
    (default: decimal year, ex. 2020.333 for 1 May 2020)\n\
  D -- input of site in \"degrees minutes\"\n\
       (default: decimal degrees, ex. 33.3 133.3)\n\
  U -- shows usage,\n\
  H -- shows help message.\n\
  F -- reads dates and site locations from a file\n\
       (only geodetic coordinate system)\n\
Format of input file:\n\
  [$ yr mo dy [alt]] <-- when omitted, 2020/1/1 & 0 km\n\
  lat lon <-- geodetic decimal coordinates\n\
  lat lon \n\
    ...\n\
  $ yr mo dy [alt] <-- another year begins\n\
  lat(d) lat(m) lon(d) lon(m) <-- in degrees & minutes\n\
    ...\n\
  $ yr [alt] <-- another year (decimal) begins\n\
  lat lon\n\
    ...\n\
(Q to quit)"

#define HEAD "Main field calculation from IGRF-13 with n=m=10\n\
  Rtn (Enter) to continue,\n\
  U for usage,\n\
  H for help message,\n\
  Q to quit.\n"

/* Gtype */

#define GEODETIC	0
#define GEOCENTRIC	1

/* Opt */

#define YMD_BIT		1
#define DEGMIN_BIT	2
#define READFILE_BIT	4

/* Others */

#define LTNPOLE 89.9999
#define LTSPOLE -89.9999

/* functions */

void ig_cmd();
void ig_readf(), ig_readf_msg();
int ig_site(), ig_check_latlon(), ig_check_degmin();
int ig_year(), ig_check_dyear(), ig_check_yr(), ig_check_mody();
