/* pc_assort_cmd -- select an item from the assorted calculations */

#include <ctype.h>
#include <math.h>
#include "pcalc.h"

extern double Slt, Sln, Plt, Pln;

static int c;
static double Xa,Ya,Za,Xb,Yb,Zb,Xc,Yc,Zc,Ma,Ia,Da,Mb,Ib,Db,Mc,Ic,Dc,Azim,Plun,Strik,Dip,\
	Fa,dFa,Vdm,dVdm,Vadm,dVadm;

int pc_assort_cmd(rem)
char *rem;
{
	fprintf(stdout, "%s ", rem);
	c = toupper(get_ch());
	if (c == ZERO) return(-1);
	else if (c == 'Q') return(ZERO);
	else return(c);
}

/* xyz_mid -- (X,Y,Z) to (M,I,D) */

void xyz_mid()
{
	while ((c=inpd("X,Y,Z?", 3, &Xa, &Ya, &Za)) != ZERO){
		if (c == -1) continue;
		carmag(Xa, Ya, Za, &Ma, &Ia, &Da);
		if (yorn("Correct orientation? (N or Rtn/Y)",-1) == ZERO){
			printf("X=%10.3e  Y=%10.3e  Z=%10.3e\n", Xa, Ya, Za);
			printf("M=%10.3e  I=%6.2f  D=%6.2f\n", Ma, Ia, Da);
		}
		else {
			while ((c=inpd("Azim,Plunge,Strike,Dip?",4,&Azim,&Plun,&Strik,&Dip)) != ZERO){
				if (c == -1) continue;
				else break;
			}
			if (c == ZERO) return;
			core(Azim, Plun, Xa, Ya, Za, &Xb, &Yb, &Zb);
			bedcor(Strik, Dip, Xb, Yb, Zb, &Xc, &Yc, &Zc);
			carmag(Xb, Yb, Zb, &Mb, &Ib, &Db);
			carmag(Xc, Yc, Zc, &Mc, &Ic, &Dc);
			printf("X=%10.3e  Y=%10.3e  Z=%10.3e\n", Xa, Ya, Za);
			printf("Core: M=%10.3e  I=%6.2f  D=%6.2f\n", Ma, Ia, Da);
			printf("Situ: M=%10.3e  I=%6.2f  D=%6.2f\n", Mb, Ib, Db);
			printf("Tilt: M=%10.3e  I=%6.2f  D=%6.2f\n", Mc, Ic, Dc);
		}
	}
}

/* mid_xyz -- (M,I,D) to (X,Y,Z) */

void mid_xyz()
{
	while ((c=inpd("M,I,D?", 3, &Ma, &Ia, &Da)) != ZERO){
		if (c == -1) continue;
		if (Ia<-90. || Ia>90. || Ma<0.){
			printf("** Error of Inclination or Magnitude! **\n");
			continue;
		}
		magcar(Ma, Ia, Da, &Xa, &Ya, &Za);
		if (yorn("Restore orientation? (N or Rtn/Y)",-1) == ZERO){
			printf("M=%10.3e  I=%6.2f  D=%6.2f\n", Ma, Ia, Da);
			printf("X=%10.3e  Y=%10.3e  Z=%10.3e\n", Xa, Ya, Za);
		}
		else {
			while ((c=inpd("Azim,Plunge,Strike,Dip?",4,&Azim,&Plun,&Strik,&Dip)) != ZERO){
				if (c == -1) continue;
				else break;
			}
			if (c == ZERO) return;
			bedcorn(Strik, Dip, Xa, Ya, Za, &Xb, &Yb, &Zb);
			coren(Azim, Plun, Xb, Yb, Zb, &Xc, &Yc, &Zc);
			carmag(Xb, Yb, Zb, &Mb, &Ib, &Db);
			carmag(Xc, Yc, Zc, &Mc, &Ic, &Dc);
			printf("Data inputted : X=%10.3e  Y=%10.3e  Z=%10.3e\n", Xa, Ya, Za);
			printf("               (M=%10.3e  I=%6.2f  D=%6.2f)\n", Ma, Ia, Da);
			printf("S & D restored: X=%10.3e  Y=%10.3e  Z=%10.3e\n", Xb, Yb, Zb);
			printf("               (M=%10.3e  I=%6.2f  D=%6.2f)\n", Mb, Ib, Db);
			printf("A & P restored: X=%10.3e  Y=%10.3e  Z=%10.3e\n", Xc, Yc, Zc);
			printf("               (M=%10.3e  I=%6.2f  D=%6.2f)\n", Mc, Ic, Dc);
		}
	}
}

/* fld_vgp -- field (I,D) at site (Slat,Slon) to vgp (Plat,Plon) */

void fld_vgp()
{
	while ((c=inpd("I,D,Slat,Slon?",4,&Ia,&Da,&Slt,&Sln)) != ZERO){
		if (c == -1) continue;
		if (Ia<-90. || Ia>90. || Slt<-90. || Slt>90.){
			printf("** Error of Inclination or Latitude! **\n");
			continue;
		}
		fldvgp(Slt, Sln, Ia, Da, &Plt, &Pln);
		printf("I=%6.2f  D=%6.2f  Slat=%6.2f  Slon=%6.2f\n", Ia, Da, Slt, Sln);
		printf("Plat=%6.2f  Plon=%6.2f\n", Plt, Pln);
	}
}

/* vgp_fld -- vgp (Plat,Plon) to field (I,D) at site (Slat,Slon) */

void vgp_fld()
{
	while ((c=inpd("Plat,Plon,Slat,Slon?",4,&Plt,&Pln,&Slt,&Sln)) != ZERO){
		if (c == -1) continue;
		if (Plt<-90. || Plt>90. || Slt<-90. || Slt>90.){
			printf("** Error of Latitude! **\n");
			continue;
		}
		vgpfld2(Slt, Sln, Plt, Pln, -1., &Ia, &Da, &Fa);
		printf("Plat=%6.2f  Plon=%6.2f  Slat=%6.2f  Slon=%6.2f\n", Plt, Pln, Slt, Sln);
		printf("I=%6.2f  D=%6.2f  F=%4.2f (for M=7.72x10^22)\n", Ia, Da, Fa/1000.);
	}
}

/* f_vdm -- total force F and Inc to VDM */

void f_vdm()
{
	while ((c=inpd("F,I,dF?", 3, &Fa, &Ia, &dFa)) != ZERO){
		if (c == -1) continue;
		if (Ia<-90. || Ia>90.){
			printf("** Error of Inclination! **\n");
			continue;
		}
		if (Fa<0. || dFa<0.){
			printf("** Input positive F & dF! **\n");
			continue;
		}
		Vdm = dpm(Fa, Ia, dFa, -1., &dVdm);
		printf("F=%6.2f  I=%6.2f  dF=%6.2f\n", Fa, Ia, dFa);
		printf("VDM=%6.3fx10^22  dVDM=%6.3fx10^22\n", Vdm, dVdm);
	}
}

/* f_vadm -- total force F at site latitude Slat to VADM */

void f_vadm()
{
	while ((c=inpd("F,Slat,dF?", 3, &Fa, &Slt, &dFa)) != ZERO){
		if (c == -1) continue;
		if (Slt<-90. || Slt>90.){
			printf("** Error of Latitude! **\n");
			continue;
		}
		if (Fa<0. || dFa<0.){
			printf("** Input positive F & dF! **\n");
			continue;
		}
		Vadm = adpm(Fa, Slt, dFa, &dVadm);
		printf("F=%6.2f  Slat=%6.2f  dF=%6.2f\n", Fa, Slt, dFa);
		printf("VADM=%6.3fx10^22  dVADM=%6.3fx10^22\n", Vadm, dVadm);
	}
}
