/* pc_meaninc -- inclination only statitsics of Arason & Levi 2010 (data number <= NMAX=50). */

#include <string.h>
#include "pcalc.h"

#define CONT " n   Im      km     a95   iteration\n%2d %6.2f %7.2f %6.2f   %5d\n"

extern char **Rjct;
extern double Ir, Km, A95, *Is, *It, *Dev;

static double incmath, kmath, dum1, dum2;

void pc_meaninc()
{
	char rem[15];
	int c, itr, i, n, m;

	while (1){
		i = 0;
		sprintf(rem, "I_%d?", i+1);
		while ((c=inpd(rem,1,&Is[i])) != -1){
			if (c == ZERO) return;
			It[i] = Is[i];
			strcpy(Rjct[i], " ");
			i++;
			sprintf(rem, "I_%d?", i+1);
			if (i >= NMAX) break;
		}
		n = i;
		if (n < 2) return;
		meanvar(n, Is, &incmath, &dum1, &dum2);
		kmath = RAD*RAD/dum1;
		printf("Arith. mean: Im=%6.2f, km=%6.2f (Rtn--continue)", incmath, kmath);
		while (yorn("",-1)){};
		itr = stati(Is, n, &Ir, &Km, &A95);
		m = n;
		pc_minc_rcal(n, m, itr);
		if (!yorn("Re-run? (N or Rtn/Y)", -1)) break;
	}
}

/* pc_minc_rcal -- re-calculation of the statistics after excluding one user selected datumn. */

void pc_minc_rcal(n, m, itr)
int n, m, itr;
{
	int c, i, j, k;

	while (1){
		for (i=0; i<n; i++) Dev[i] = Is[i] - Ir;
		printf(" i      I     dev\n");
		for (i=0; i<n; i++) printf("%2d %1s %6.2f %6.2f\n", i+1, Rjct[i], Is[i], Dev[i]);
		printf(CONT, m, Ir, Km, A95, itr);
		if (m<3 || !yorn("Exclude one? (N or Rtn/Y)", -1)) break;
		else {
			while ((c=inpi("i?",1,&j)) != ZERO){
				if (c == -1) continue;
				if (j<1 || j>n) continue;
				strcpy(Rjct[j-1], "*");
				break;
			}
		}
		for (i=0,k=0; i<n; i++){
			if (strcmp(Rjct[i],"*") != ZERO){
				It[k] = Is[i];   k++;
			}
		}
		m = k;
		meanvar(m, It, &incmath, &dum1, &dum2);
		kmath = RAD*RAD/dum1;
		printf("Arith. mean: Im=%6.2f, km=%6.2f (Rtn--continue)", incmath, kmath);
		while (yorn("",-1)){};
		itr = stati(It, m, &Ir, &Km, &A95);
	}
}
#undef CONT
