/* pc_meanuvec2 -- Fisher statistics of unit vectors from a file.
	data number is limitless, but recalculation option is not available.   0919
*/

#include <stdlib.h>
#include <string.h>
#include "pcalc.h"

extern FILE *Fp;
extern char Filed[];
extern int Optl;
extern double Slt, Sln, Plt, Pln, Ir, Dr, Km, R, A95, Dp, Dm, Asd, *Is, *Ds, *Dev;

void pc_meanuvec2(type)
int type;
{
	char s1[30], s2[30], s3[30], cnt[300];
	int c, i, n, m;

	i = 0;
	while ((c=get_s(Fp,3,s1,s2,s3)) != EOF){
		if (c==0 || s1[0]=='#' || s1[0]=='%' || s1[0]=='$') continue;
		i++;
	}
	n = i;
	Is = mallocvd(n);  Ds = mallocvd(n);  Dev = mallocvd(n);
	rewind(Fp);

	i = 0;
	Slt = Sln = 0.;
	while ((c=get_s(Fp,3,s1,s2,s3)) != EOF){
		if (c==0 || s1[0]=='#' || s1[0]=='%') continue;
		if (s1[0] == '$'){
			Slt = atof(s2);   Sln = atof(s3);
			continue;
		}
		if (c < 2) error("Lack of data detected!");
		Is[i] = atof(s1);   Ds[i] = atof(s2);
		i++;
	}
	if (n != i) error("Error of count data!");
	if (n < 1) return;
	statf2(Is, Ds, n, &Ir, &Dr, &R, &Km, &A95, &Asd);
	m = n;
	printf("Fisher statistics of %s:\n", Filed);
	if (type == FIELD){
		strcpy(cnt, " Slat   Slon   n   I      D       R      k      a95   Plat   Plon    dp     dm     asd\n");
		strcat(cnt, "%6.2f %6.2f %2d %6.2f %6.2f %6.3f %7.2f %6.2f %6.2f %6.2f %6.2f %6.2f %6.2f\n");
	}
	else {
		strcpy(cnt, " n  Plat   Plon     R      k      A95    Asd\n");
		strcat(cnt, "%2d %6.2f %6.2f %6.3f %7.2f %6.2f %6.2f\n");
	}
	if (type == FIELD){
		fldvgp2(Slt, Sln, Ir, Dr, A95, &Plt, &Pln, &Dp, &Dm);
		printf(cnt, Slt, Sln, m, Ir, Dr, R, Km, A95, Plt, Pln, Dp, Dm, Asd);
		if (Optl == 1){
			anglesd(Ir, Dr, n, Is, Ds, Dev);
			printf("Input data:\n i    I      D     dev\n");
			for (i=0; i<n; i++)
				printf("%2d %6.2f %6.2f %6.2f\n", i+1, Is[i], Ds[i], Dev[i]);
		}
	}
	else {
		printf(cnt, m, Ir, Dr, R, Km, A95, Asd);
		if (Optl == 1){
			anglesd(Ir, Dr, n, Is, Ds, Dev);
			printf("Input data:\n i  Plat   Plon    dev\n");
			for (i=0; i<n; i++)
				printf("%2d %6.2f %6.2f %6.2f\n", i+1, Is[i], Ds[i], Dev[i]);
		}
	}

	freevd(Is);  freevd(Ds);  freevd(Dev);
	fclose(Fp);
}
/* pc_muvec_rcal(type, n, m); */
