/* pcalc.h -- header file for pcalc   0919,0519 */

#include "std.h"

#define USAGE "Usage: pcalc -A [-H] [-F [-V] [-I] [-G] [-B] [-C] file [-L]]"

#define HELP "HELP MESSAGE OF PCALC\n\
  Assorted miscellaneous pmag calculations V3.6, H. Tanaka, 2020\n\
Usage: (only one option works)\n\
  pcalc -A [-H] [-F [-V] [-I] [-G] [-B] [-C] file [-L]]\n\
Options:\n\
  A -- assorted interactive calculations\n\
  H -- help message\n\
  F -- Fisher statistics of fields from a file\n\
  V -- Fisher statistics of VGPs from a file\n\
  I -- inclination only statistics from a file\n\
  G -- geomag elements of IGRF from a file\n\
  B -- Bingham statistics from a file\n\
  C -- circle fitting from a file\n\
  L -- list input data from a file when used\n\
       with F, V, I, B, C options.\n\
Format of input file:\n\
  F:\n\
    [$ slat slon] <-- when omitted, slat=slon=0 is given\n\
    inc dec\n\
      ...\n\
  V:\n\
    plat plon\n\
       ...\n\
  I:\n\
    inc\n\
    ...\n\
  G:\n\
    [$ year] <-- when omitted, 2020.0 is supposed\n\
    slat slon\n\
       ...\n\
  B:\n\
    inc dec (plat plon)\n\
      ...\n\
  C:\n\
    x y\n\
    ...\n\
(Q to quit)"

#define ITEMS "Miscellaneous Calculations in Paleomagnetism V3.3\n\
  1: X,Y,Z  -> M,I,D    2: M,I,D   -> X,Y,Z\n\
  3: Field  -> VGP      4: VGP     -> Field\n\
  5: F,I    -> VDM      6: F,Lat   -> VADM\n\
  7: Flds   -> Mean Fld 8: VGPs    -> Mean VGP\n\
  9: I only -> Mean I   A: Lat,Lon -> IGRF\n\
  B: Bingham statistics of Flds or VGPs\n\
  C: Circle fitting of X-Y data points\n\
(Q to quit)"

#define ASSORT	0
#define FIELD	1
#define VGP	2
#define INCONLY	3
#define IGRF	4
#define BING	5
#define CIRC	6

#define NMAX	50

int pc_cmd();
void pc_assort();
int pc_assort_cmd(); void xyz_mid(), mid_xyz(), fld_vgp(), vgp_fld(), f_vdm(), f_vadm();
void pc_meanuvec(), pc_muvec_rcal();
void pc_meanuvec2();
void pc_meaninc(), pc_minc_rcal();
void pc_meaninc2();
void pc_mag_igrf(), pc_mag_igrf2();
void pc_bing(), cal_bing(), pc_bing2();
void pc_circ(), pc_circ_rcal(), pc_cal_kc(), pc_cal_er(), pc_circ2();
