/* sp2m.h -- header file for sp2m */

#include "std.h"

#define USAGE	"Usage: sp2m [-C -S [-T] -N -H] file1 file2 ..."
#define HELP	"HELP MESSAGE OF SP2M\n\
  Convert Natsuhara\'s SPIN2 file V2.0, H. Tanaka, 2015\n\
  For new format files (*.txt) and the output data are for use by\n\
  \"pdemag\" or \"pdirec\". For old format (_*.txt) use \"_sp2m\".\n\
\n\
Usage:\n\
  sp2m [-C -S [-T] -N -H] file1 file2 ...\n\
\n\
Options:\n\
  C -- core coordinates data are taken\n\
  S -- in situ coordinates data\n\
 [T]-- bedding corrected data (default)\n\
  N -- for NRM measurements with output format for \"pdirec\"\n\
  H -- shows a help message\n\
\n\
Input files:\n\
  Natsuhara\'s new formatted file (*.txt) of SPIN2, which are\n\
  either of step-wise demagnetization data from a single sample,\n\
  or NRM measurements of multiple samples from a single site.\n\
  Reads <=50 files but use of a wild card \"*\" is NOT supported.\n\
\n\
Output files:\n\
  Results are written to stdout with either of the following formats.\n\
    Default, C, S options (for use by \"pdemag\"):\n\
      $ file 0.0 0.0 0.0 0.0 (orientation info is set to zero)\n\
      step M I D             (coordinates depends on the option)\n\
        ...\n\
        ...\n\
    N option (for use by \"pdirec\"):\n\
      $ file\n\
      sample Ic Dc Is Ds It Dt -1.0 A 1 M (\"-1.0 A 1\" are dummies)\n\
        ...\n\
        ...\n\
  To save to a file use redirect as \"sp2m file1 file2 ... > outfile\"\n\
(Q to quit)"

/* some definitions */

#define NFILES	50
#define LFILES	200
#define LBUF	200
#define CORE	0
#define SITU	1
#define TILT	2

/* for unsigned int Opt */

#define NRM_BIT	1

/* functions */

int sp2m_cmd(); void revorder();
void sp2m_cal(), sp2m_dat();
void sp2m_caln(), sp2m_datn();
