/* sp2m_cal -- take data for "pdemag" from nth spinner file 
	modified to read new style files (*.txt) of Natsuhara's Spinner 2000   080712
*/

#include <string.h>
#include <stdlib.h>
#include "sp2m.h"

#define ERRMSG "sp2m_cal: error in reading a file!"
#define CONT0 "$ %s 0.0 0.0 0.0 0.0\n"
#define CONT "%4s %9.3e %5.1f %6.1f\n"

extern char Files[][LFILES];
extern int Frame;

void sp2m_cal(n)
int n;
{
	FILE *fp;
	char step[50], buf[LBUF];
	double azim, plun, strik, dip, x, y, z, mag, inc, dec;

	if ((fp = fopen(Files[n], "r")) == NULL) error("sp2m_cal: error in fopen!");
	if (getstr(fp, buf, LBUF) == EOF) error(ERRMSG);
	fprintf(stdout, CONT0, Files[n]);
	while (getstr(fp, buf, LBUF) != EOF){
		sp2m_dat(buf, step, &mag, &inc, &dec);
		fprintf(stdout, CONT, step, mag, inc, dec);
	}
	fclose(fp);
}

void sp2m_dat(buf, step, mag, inc, dec)
char *buf, *step;
double *mag, *inc, *dec;
{
	char *ptoken, *delims = "\"() ,", Token[12][50];
	int ni, i;

	i = 0;
	ptoken = strtok(buf, delims);
	while (ptoken != NULL){
		if (i >= 12) break;
		strcpy(Token[i++], ptoken);
		ptoken = strtok(NULL, delims);
	}
	ni = i;
	if (ni < 12) error("Error in numbers of data read!");
	strcpy(step, Token[0]);
	*mag = atof(Token[5]);
	switch(Frame){
	case CORE:
		*inc = atof(Token[7]);  *dec = atof(Token[6]);
		break;
	case SITU:
		*inc = atof(Token[9]);  *dec = atof(Token[8]);
		break;
	case TILT:
		*inc = atof(Token[11]);  *dec = atof(Token[10]);
		break;
	default:
		break;
	}
}
#undef ERRMSG
#undef CONT0
#undef CONT
