/* sp2m_caln -- take data for "pdirec" from nth spinner file 
	modified to read new style files (*.txt) of Natsuhara's Spinner 2000   080712
*/

#include <string.h>
#include <stdlib.h>
#include "sp2m.h"

#define ERRMSG "sp2m_caln: error in reading a file!"
#define CONT0 "$ %s\n"
#define CONT "%8s %5.1f %6.1f %5.1f %6.1f %5.1f %6.1f -1.0 A 1 %10.3e\n"

extern char Files[][LFILES];

void sp2m_caln(n)
int n;
{
	FILE *fp;
	char sample[50], buf[LBUF];
	double mag, incc, decc, incs, decs, inct, dect;

	if ((fp = fopen(Files[n], "r")) == NULL) error("sp2m_caln: error in fopen!");
	if (getstr(fp, buf, LBUF) == EOF) error(ERRMSG);
	fprintf(stdout, CONT0, Files[n]);
	while (getstr(fp, buf, LBUF) != EOF){
		sp2m_datn(buf, sample, &incc, &decc, &incs, &decs, &inct, &dect, &mag);
		fprintf(stdout, CONT, sample, incc, decc, incs, decs, inct, dect, mag);
	}
	fclose(fp);
}

void sp2m_datn(buf, sample, incc, decc, incs, decs, inct, dect, mag)
char *buf, *sample;
double *incc, *decc, *incs, *decs, *inct, *dect, *mag;
{
	char *ptoken, *delims = "\"() ,", Token[12][50];
	int ni, i;

	i = 0;
	ptoken = strtok(buf, delims);
	while (ptoken != NULL){
		if (i >= 12) break;
		strcpy(Token[i++], ptoken);
		ptoken = strtok(NULL, delims);
	}
	ni = i;
	if (ni < 12) error("Error in numbers of data read!");
	strcpy(sample, Token[0]);
	*mag = atof(Token[5]);
	*incc = atof(Token[7]);  *decc = atof(Token[6]);
	*incs = atof(Token[9]);  *decs = atof(Token[8]);
	*inct = atof(Token[11]);  *dect = atof(Token[10]);
}
#undef ERRMSG
#undef CONT0
#undef CONT
