/* sp2m_cmd -- command interpretation of sp2m */

#include <ctype.h>
#include <string.h>
#include "sp2m.h"

#define ERROPT "Except \"-N\", assign only one option!"

extern char Files[][LFILES];
extern unsigned Opt;
extern int Frame;

int sp2m_cmd(argc, argv)
int argc;
char *argv[];
{
	char *s;
	int i = 0, nf, flag = 0;

	if (argc < 2) error(USAGE);
	while (--argc > 0){
		if (*argv[argc] == '-'){
			s = argv[argc] + 1;
			while (*s != '\0'){
				switch (toupper(*s)){
				case 'C':
					if (flag != 0) error(ERROPT);
					Frame = CORE;
					flag = 1;
					break;
				case 'S':
					if (flag != 0) error(ERROPT);
					Frame = SITU;
					flag = 1;
					break;
				case 'T':
					if (flag != 0) error(ERROPT);
					Frame = TILT;
					flag = 1;
					break;
				case 'N':
					Opt |= NRM_BIT;
					break;
				case 'H':
					showless(HELP);
					break;
				default:
					error("Unknown option!");
					break;
				}
			s++;
			}
		}
		else {
			if (i >= NFILES) error("sp2m_cmd: too many files!");
			strcpy(Files[i++], argv[argc]);
		}
	}
	nf = i;
	revorder(nf);
	return(nf);
}

/* revorder -- reverse order of Files[][] */

void revorder(n)
int n;
{
	char temp[LFILES];
	int i, j;

	i = 0;   j = n - 1;
	while (i < j){
		strcpy(temp, Files[i]);
		strcpy(Files[i], Files[j]);
		strcpy(Files[j], temp);
		i++;   j--;
	}
}
