#include   <math.h>
#include   "std.h"

/* bedcor -- separated from remane. transfer from in situ direction to tilt corrected
	by strike (east +) and dip (down +)   051918,0691,0786
	strik  bedding correction, eastward positive from magnetic north
	dip    bedding correction, downward positive
*/

void bedcor(strik, dip, x0, y0, z0, x, y, z)
double strik, dip, x0, y0, z0, *x, *y, *z;
{
	double x1, y1, z1;

	rotvec(-strik, -dip, x0, y0, z0, &x1, &y1, &z1);
	rotvec(strik, 0., x1, y1, z1, x, y, z);
}

/* bedcorn -- restore in situ direction from tilted direction */

void bedcorn(strik, dip, x0, y0, z0, x, y, z)
double strik, dip, x0, y0, z0, *x, *y, *z;
{
	double x1, y1, z1, x2, y2, z2;

	rotvec(-strik, 0., x0, y0, z0, &x1, &y1, &z1);
	rotvec(0., dip, x1, y1, z1, &x2, &y2, &z2);
	rotvec(strik, 0., x2, y2, z2, x, y, z);
}
