#include <math.h>
#include "std.h"

/* vecsub -- vector subtraction given by c = a - b   08/25/00 */

void vecsub(amag, ainc, adec, bmag, binc, bdec, cmag, cinc, cdec)
double amag, ainc, adec, bmag, binc, bdec, *cmag, *cinc, *cdec;
{
	double ax, ay, az, bx, by, bz, cx, cy, cz;

	magcar(amag, ainc, adec, &ax, &ay, &az);
	magcar(bmag, binc, bdec, &bx, &by, &bz);
	cx = ax - bx;   cy = ay - by;   cz = az - bz;
	carmag(cx, cy, cz, cmag, cinc, cdec);
}


/* vecadd -- vector addition given by c = a + b   08/25/00 */

void vecadd(amag, ainc, adec, bmag, binc, bdec, cmag, cinc, cdec)
double amag, ainc, adec, bmag, binc, bdec, *cmag, *cinc, *cdec;
{
	double ax, ay, az, bx, by, bz, cx, cy, cz;

	magcar(amag, ainc, adec, &ax, &ay, &az);
	magcar(bmag, binc, bdec, &bx, &by, &bz);
	cx = ax + bx;   cy = ay + by;   cz = az + bz;
	carmag(cx, cy, cz, cmag, cinc, cdec);
}


/* angdif -- angular difference delta between a and b   08/25/00 */

double angdif(amag, ainc, adec, bmag, binc, bdec)
double amag, ainc, adec, bmag, binc, bdec;
{
	double dlt, cosi1, cosi0, cosd, sini1, sini0;

	cosi1 = cos(ainc/RAD);   cosi0 = cos(binc/RAD);
	cosd = cos( (adec - bdec)/RAD );
	sini1 = sin(ainc/RAD);   sini0 = sin(binc/RAD);
	dlt = acos( cosi1*cosi0*cosd + sini1*sini0 );
	return(dlt*RAD);
}
