/* igrfdec -- geomagnetic declination predicted from IGRF-13   040320,0319 */

#include <math.h>
#include "sunpmag.h"

#define N 10
#define GEODETIC 0
#define HEIGHT 0.

double igrfdec(year, month, day, lat, lon, dyear)
int year, month, day;
double lat, lon, *dyear;
{
	double x, y, z, f, inc, dec, **G, **H, dum;

	G = mallocmd(N+1, N+1);   H = mallocmd(N+1, N+1);
	*dyear = ymdtoy(year, month, day, &dum);
	if (gausscoeff(*dyear,N,G,H) == -1)
		error("Years supported are 1900.0<=year<=2025.0!");
	gaussfld(GEODETIC, lat, lon, HEIGHT, N, &x, &y, &z, G, H);
	carmag(x, y, z, &f, &inc, &dec);
	checklon(&dec, 1);
	freemd(N+1, G);   freemd(N+1, H);
	return dec;
}
#undef N
#undef GEODETIC
#undef HEIGHT
