/* sunpmag.h -- header file for sunpmag.c   040320,031019 */

#include "std.h"

#define USAGE	"Usage: sunpmag file [-H]"

#define HELP	"HELP MESSAGE OF SUNPMAG\n\
  Core azimuth from the sun orientation V.2.3, H. Tanaka, 2020\n\
Usage:\n\
  sunpmag file [-H]\n\
Input data:\n\
  Applicable ONLY to the orientation device supplied by Natsuhara Giken.\n\
  Simple description of the input data are as the followings.\n\
    lat,lon -- decimal latitude & longitude of site locality\n\
    tzone -- east positive time difference (ex., +9 for Japan)\n\
    dec -- optional local dec (when omitted, IGRF value is given\n\
           with n=m=10 for geodetic system with altitude 0 km)\n\
    plun -- plunge of the core (not used in the azimuth calculation)\n\
    ref_azim -- optional reference azimuth (eastward from the true north)\n\
    mag -- marker angle measured COUNTERCLOCKWISE from the magnetic north\n\
    sun -- sun angle measured clockwise from a marker (NOT sun's shadow)\n\
    ref -- reference angle measured clockwise from a marker\n\
Input file format:\n\
  # lines beginning with \"#\" or \"%\", or blank line are ignored\n\
  $$ lat lon tzone [dec] -- line with \"$$\" at the top is the locality\n\
  $ year month day [ref_azim] -- line with \"$\" begins site data\n\
  core1-1 plun mag               -- case of plun and mag only\n\
  core1-2 plun mag sun h m s     -- case of plun, mag, sun, and time\n\
  core1-3 plun mag ref           -- case of plun, mag, and ref\n\
  core1-4 plun mag sun h m s ref -- case of all measurements\n\
          .\n\
          .\n\
  $ year month day [ref_azim]    -- another site data begins\n\
  core2-1 plun mag sun h m s\n\
          .\n\
  $$ lat lon tzone [dec]         -- another locality begins\n\
          .\n\
Output File:\n\
  Results are print out to \"stdout\". To save them to a file, type as\n\
    \"sunpmag in_file > out_file\"\n\
(Q to quit)"

/* Type of functions */

void print1(), print2(), print2a(), print3(), print4(), print5(), print6(), print7(), print8();
double igrfdec();
