/* tmean.h -- header file for tmean */

#include "std.h"

#define USAGE	"Usage: tmean file [-Ppc -Ddiff -L -H]"
#define HELP	"HELP MESSAGE OF TMEAN\n\
  Test of a common mean V1.2, H. Tanaka, 2018.\n\
  Whether two scalar samples share a common mean is tested by\n\
  Student's t-test (common variance) or Welch's t-test (different variances).\n\
\n\
Usage:\n\
  tmean file [-Ppc -Ddiff -L -H]\n\
\n\
Options:\n\
  P -- significance level (default: 0.05)\n\
  D -- tests if mu1-mu2=diff (default: 0)\n\
      (assign a negative diff for mu2>mu1)\n\
  L -- lists original data at the last\n\
  H -- help message\n\
\n\
Input file:\n\
  Data of sample 1 and sample 2 should be contained in a single file with\n\
  one datum per line. They are divided by a line with first letter \'>\' or \'<\'.\n\
  Lines with first letter \'#\' or \'%\' are comments and are ignored.\n\
\n\
  Format:\n\
  # comment line can be placed at any place\n\
  X11 [notes ...] -- notes can be put after the datum\n\
  X12\n\
  X13\n\
    ...\n\
  >               -- this line separates two samples\n\
  X21\n\
  X22\n\
  X23\n\
   ...\n\
\n\
Output:\n\
  Results are written to stdout. To save them to a file,\n\
  use redirect as \"tmean in_file > out_file\".\n\
(Q to quit)"

/* Option for Opt */

/* #define MEAN_DIFF	1 */
#define LIST_DATA	2

/* Type of functions */

FILE *tmcmd();
void tmread();
double tmtestf(), tmtestt(), tmtestw();
