/* tmread -- counts data lines, allocates memories, and reads data.  */

#include <stdlib.h>
#include "tmean.h"

extern int N, N1, N2;
extern double *X1, *X2;

void tmread(fp)
FILE *fp;
{
	char s[100];
	int n, i;

	i = N1 = 0;
	while ((n = get_s(fp, 1, s)) != EOF){
		if (n==0 || s[0]=='#' || s[0]=='%') continue;
		else if (s[0]=='>' || s[0]=='<'){
			N1 = i;
			break;
		}
		i++;
	}
	i = N2 = 0;
	while ((n = get_s(fp, 1, s)) != EOF){
		if (n==0 || s[0]=='#' || s[0]=='%') continue;
		else if (s[0]=='>' || s[0]=='<')
			error("More than one data separator \'>\'!");
		i++;
	}
	N2 = i;   N = N1 + N2;
	if (N1<3 || N2<3) error("Number of data should be more than two!");
	X1 = mallocvd(N1);  X2 = mallocvd(N2);
	rewind(fp);
	i = 0;
	while ((n = get_s(fp, 1, s)) != EOF){
		if (n==0 || s[0]=='#' || s[0]=='%') continue;
		else if (s[0]=='>' || s[0]=='<') break;
		X1[i] = atof(s);
		i++;
	}
	if (N1 != i) error("Error of data counting!");
	i = 0;
	while ((n = get_s(fp, 1, s)) != EOF){
		if (n==0 || s[0]=='#' || s[0]=='%') continue;
		X2[i] = atof(s);
		i++;
	}
	if (N2 != i) error("Error of data counting!");
	fclose(fp);
}
