/* tmdcmd -- command interpretation for tmeandir */

#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "tmeandir.h"

extern char Filed[NFILENAME];
extern unsigned int Opt;
extern int NI;
extern double Pc;

FILE *tmdcmd(argc, argv)
int argc;
char *argv[];
{
	FILE *fp;
	char *s;
	int flagf = 0;

	if (argc < 2) error(USAGE);
	while (--argc > 0){
		if (*argv[argc] == '-'){
			s = argv[argc] + 1;
			switch (toupper(*s)){
			case 'R':
				Opt |= INVERT_GRP2;
				break;
			case 'P':
				Pc = atof(s+1);
				if (Pc<0.001 || Pc>0.5)
					error("Assign 0.001<=Pc<=0.5 for significance level!");
				break;
			case 'N':
				NI = atoi(s+1);
				if (NI<1000 || NI>100000)
					error("Number of iteration is too small or too large!");
				break;
			case 'L':
				Opt |= LIST_DATA;
				break;
			case 'H':
				showless(HELP);
				break;
			default:
				error("Unknown option!");
				break;
			}
		}
		else {
			if (flagf != 0) error("Assign only one file!");
			strcpy(Filed, argv[argc]);
			if ((fp = fopen(Filed, "r")) == NULL) error("Error of open file!");
			flagf = 1;
		}
	}
	if (flagf != 0) return(fp);
	else error("Error of open file!");
}
/*
if (Pc!=.1 && Pc!=.05 && Pc!=.025 && Pc!=.01 && Pc!=.005)
error("Significance level should be one of 0.1, 0.05, 0.025, 0.01, and 0.005!");
*/
