/* tmdmem -- counts data lines and allocates memories.
	Variables:
		N -- total number of data (directions)
		M -- number of groups (distributions)
	Counters:
		i -- counts data lines
		j -- counts division markers
		Nm[j], Np[j] -- see tmdread().
*/

#include <stdlib.h>
#include "tmeandir.h"

extern int N, M, *Nm, *Np;
extern double *Inc, *Dec, *Incr, *Decr, *R, *K, *A95;

void tmdmem(fp)
FILE *fp;
{
	char s[50];
	int n, i, j;

	i = 0;   j = 0;
	while ((n = get_s(fp, 1, s)) != EOF){
		if (n==0 || s[0]=='#' || s[0]=='%') continue;
		else if (s[0]=='>' || s[0]=='<'){
			j++;
			continue;
		}
		i++;
	}
	N = i;
	M = ++j;
	Nm = mallocvi(M+1);   Np = mallocvi(M+1);
	Inc = mallocvd(N);  Dec = mallocvd(N);
	Incr = mallocvd(M);  Decr = mallocvd(M);
	R = mallocvd(M);  K = mallocvd(M);  A95 = mallocvd(M);
	rewind(fp);
}
