/* tmeandir -- test of mean directions by McFadden & Lowes (1981)   121098
	V.1.1 -- right-hand side of (24a) is shown for easy check of k1=k2   070505
	V.2.0 -- simplified to unit vecotors; (inc,dec) or (plat,plon).   090118
		 classification of reversal test by McFadden & McElhinny (1990) was added.
		 when not equal kappa for two or multi groups, test by simulation was introduced.
	Variables:
		N     -- total number of data (directions)
		M     -- number of groups (distributions)
		Nm[j] -- number of data in (j+1)th group
		Np[j] -- pointer to the first datum in (j+1)th group
*/

#include "tmeandir.h"

char Filed[NFILENAME];
unsigned int Opt = 0;
int NI = 2500, N, M, *Nm, *Np;
double Pc = 0.05, *Inc, *Dec, *Incr, *Decr, *R, *K, *A95, Inct, Dect, Rt, Kt, A95t;

int main(argc, argv)
int argc;
char *argv[];
{
	char *invg2[] = {"", " (2nd group inverted)"};
	FILE *fp;
	int i, j, k;

	if ((fp = tmdcmd(argc, argv)) == NULL) error("Error of file open!");
	tmdmem(fp);
	tmdread(fp);
	fprintf(stdout, "Data file:\n  %s\n", Filed);
	if (M==2 && Nm[1]==1){
		fprintf(stdout, "Case:\n  two groups (1 DATUM ONLY in 2nd group, p = %.3f)\n", Pc);
		tmdstat1();
	}
	else if (M == 2){
		fprintf(stdout, "Case:\n  two groups (significance level = %.3f)\n", Pc);
		tmdstat2();
	}
	else if (M >= 3){
		fprintf(stdout, "Case:\n  multi groups (M=%d, significance level = %.3f)\n", M, Pc);
		tmdstatm();
	}
	fprintf(stdout, "Group & total means%s:\n  grp  n   incr   decr    R        k       a95\n", invg2[Opt & INVERT_GRP2]);
	for (j=0; j<M; j++)
		fprintf(stdout, "  %2d  %2d  %5.1f  %5.1f  %7.4f  %7.3f  %4.1f\n", \
				j+1, Nm[j], Incr[j], Decr[j], R[j], K[j], A95[j]);
	fprintf(stdout, "   T  %2d  %5.1f  %5.1f  %7.4f  %7.3f  %4.1f\n", \
			N, Inct, Dect, Rt, Kt, A95t);
	if (Opt & LIST_DATA){
		fprintf(stdout, "List of data%s:\n   i  j  k   inc    dec\n", invg2[Opt & INVERT_GRP2]);
		i = 0;
		for (j=0; j<M; j++){
			for (k=0; k<Nm[j]; k++){
				fprintf(stdout, "  %2d %2d %2d  %5.1f  %5.1f\n",\
						i+1, j+1, k+1, Inc[i], Dec[i]);
				i++;
			}
			if (j < M-1) fprintf(stdout, ">\n");
		}
	}
	freevi(Nm); freevi(Np);
	freevd(Inc); freevd(Dec); freevd(Incr); freevd(Decr); freevd(R); freevd(K); freevd(A95);
}
