/* tmeandir.h -- header file for tmeandir */

#include "std.h"

#define USAGE	"Usage: tmeandir file [-R -Ppc -Nni -L -H]"
#define HELP	"HELP MESSAGE OF TMEANDIR\n\
  Test of a common mean direction V2.0, H. Tanaka, 2018\n\
  Whether two or more distributions share a common mean direction is tested\n\
  following McFadden & Lowes (1981), McFadden & McElhinny (1990), and\n\
  Fisher et al. (1987).\n\
\n\
Usage:\n\
  tmeandir file [-R -Ppc -Nni -L -H]\n\
\n\
Options:\n\
  R -- invert 2nd group directions\n\
  P -- significance level (default: 0.05)\n\
  N -- number of iteration (default: 2500)\n\
  L -- list input data at the last\n\
  H -- help message\n\
\n\
Input file:\n\
  Three or more data of (Inc,Dec) or (Plat,Plon) for each distribution,\n\
  which are divided by a line with first letter \'>\' or \'<\'.\n\
  Lines with first letter \'#\' or \'%\' are comments and are ignored.\n\
  For the case of two distributions, 2nd group can be a single datum,\n\
  in which case test of outlier of McFadden (1982) is also given.\n\
\n\
  Format:\n\
  # comment line can be placed at any place\n\
  inc11 dec11 [notes ...] -- notes can be put at the last\n\
  inc12 dec12\n\
    ...\n\
  >                      -- this line separates each group\n\
  inc21 dec21\n\
  inc22 dec22\n\
   ...\n\
  >\n\
  inc31 dec31            -- test of multi group is allowed\n\
   ...\n\
\n\
Output:\n\
  Results are written to stdout. To save them to a file,\n\
  use redirect as \"tmeandir in_file > out_file\".\n\
(Q to quit)"

/* options for unsigned int Opt */

#define INVERT_GRP2	1
#define LESS_THAN_5	2
#define LIST_DATA	4

/* Type of functions */

FILE *tmdcmd();
void tmdmem();
void tmdread();
void tmdstat1();
void tmdstat2(), tmdsetclass(); double tmdcalf(), tmdcalfr(), tmdcosgammc(), tmdcosgammcr();
void tmdstat2s(); double calranv();
void tmdstatm(); double tmdcalk(), tmdcalG(), tmdcalg();
void tmdstatms(); double calranvm();
